<?php
$servername = 'localhost';
$username = 'root';
$password = '';
$database = 'delphi';

// Create connection
$conn = new mysqli($servername, $username, $password, $database);

// Check connection
if ($conn->connect_error) {
    die('Connection failed: ' . $conn->connect_error);
} 

$sql = 
	"SELECT\n"
	."	posts.post_id,\n"
	."	posts.post_time,\n"
	."	posts.post_readflag,\n"
	."	posts.post_replytopost_id,\n"
	."	posts.post_replytouser_id,\n"
	."	posts_text.post_text,\n"
	."	topics.topic_title,\n"
	."	subjects.subject_text,\n"
	."	from_username_table.username as user_from,\n"
	."	to_username_table.username as user_to\n"


	."	FROM `posts`\n"
	."INNER JOIN posts_text ON posts.post_body_id=posts_text.post_id\n"
	."LEFT OUTER JOIN users as from_username_table ON posts.post_poster_id=from_username_table.user_id\n"
	."LEFT OUTER JOIN users as to_username_table ON posts.post_replytouser_id=to_username_table.user_id\n"
	."LEFT OUTER JOIN topics ON posts.post_topic_id=topics.topic_id\n"
	."LEFT OUTER JOIN subjects ON posts.post_subject_id=subjects.subject_id\n"
	."ORDER BY posts.post_id\n"
	//."LIMIT 0,3\n"
	.";\n"
	;

$result = $conn->query($sql);
if($result === false)
{
    die('Query failed: ' . $conn->error);
}
if (isset($result) && $result->num_rows > 0)
{
	$nameWidth = 13;
	$dateMaxWidth = 12;
	$indent = '     ';

    // output data of each row
    while($row = $result->fetch_assoc())
	{
		$id = strval($row['post_id']);
		$idWidth = max(4, strlen($id)) + 1;
		$idText = $id.str_repeat(' ', $idWidth - strlen($id));
		$dateText = strtoupper(gmdate('jMy-Hi', $row['post_time']));
		$dateText = str_repeat(' ', $dateMaxWidth - strlen($dateText)).$dateText;
		$topicText = (strlen($row['topic_title']) > 0 ? ' ' : '').$row['topic_title'];

		$subjectText = $row['subject_text'];
		$subjectPrefix = (int)$row['post_replytopost_id'] !== 0 ?  'RE: ' : '';
		$subjectPrefix = '';
		$subjectPostfix = (int)$row['post_replytopost_id'] !== 0 ?  " (Re: Msg {$row['post_replytopost_id']})" : '';

		$fromUsername = $row['user_from'].str_repeat(' ', $nameWidth - strlen($row['user_from']));
		$toUsername = $row['user_to'];
		$readState = $row['post_readflag'] == false ? ' (NR)' : '';

        echo $idText.$dateText.$topicText."\n";
        echo $indent.$subjectPrefix.$subjectText.$subjectPostfix."\n";
		echo $indent.'From: '.$fromUsername.'To: '.$toUsername.$readState."\n";
        echo " \n";
		echo $row['post_text'];
		echo "-*-\n";
		echo " \n";
    }
} else {
    echo '0 results';
}
$conn->close();

?>